config/routes.rb
Rails.application.routes.draw do
  devise_for :admins
  devise_for :users
  resources :cardapios
  get 'home' => 'home#home'
  get 'cardapio1' => 'home#cardapio1'
  get 'entrar' => 'home#entrar'
  get 'cadastro' => 'home#cadastro'
  get "fale_conosco" => 'home#fale_conosco'
  root :to => 'home#home'
  
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :trackable, :timeoutable, :lockable
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cardapio.rb
class Cardapio < ApplicationRecord
  validates :nome , :descricao , :preco , :link_imagem , presence: true
  validates :preco , numericality: true

  def attr(contador)
    valor = contador.to_f
    return valor
  end

end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception

  def checar_adm()
    if user_signed_in?
    if current_user.email == 'vitor@gmail.com' || current_user.email == 'lclaudio.tl@gmail.com'
    end
  end
end
end

app/controllers/cardapios_controller.rb
class CardapiosController < ApplicationController
  before_action :set_cardapio, only: [:show, :edit, :update, :destroy]

  # GET /cardapios
  # GET /cardapios.json
  def index
    @cardapios = Cardapio.all
  end

  # GET /cardapios/1
  # GET /cardapios/1.json
  def show
  end

  # GET /cardapios/new
  def new
    @cardapio = Cardapio.new
  end

  # GET /cardapios/1/edit
  def edit
  end

  # POST /cardapios
  # POST /cardapios.json
  def create
    @cardapio = Cardapio.new(cardapio_params)

    respond_to do |format|
      if @cardapio.save
        format.html { redirect_to @cardapio, notice: 'Alimento criado com sucesso.' }
        format.json { render :show, status: :created, location: @cardapio }
      else
        format.html { render :new }
        format.json { render json: @cardapio.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cardapios/1
  # PATCH/PUT /cardapios/1.json
  def update
    respond_to do |format|
      if @cardapio.update(cardapio_params)
        format.html { redirect_to @cardapio, notice: 'Alimento atualizado com sucesso.' }
        format.json { render :show, status: :ok, location: @cardapio }
      else
        format.html { render :edit }
        format.json { render json: @cardapio.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cardapios/1
  # DELETE /cardapios/1.json
  def destroy
    @cardapio.destroy
    respond_to do |format|
      format.html { redirect_to cardapios_url, notice: 'Alimento destruido com sucesso.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cardapio
      @cardapio = Cardapio.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cardapio_params
      params.require(:cardapio).permit(:nome, :descricao, :preco, :link_imagem)
    end
end

app/controllers/entrar_controller.rb
class EntrarController < ApplicationController
  def login
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def home
  end
  def cardapio1
    @cardapio= Cardapio.all
  end
  def entrar
  end
  def cadastro
  end
  def fale_conosco
  end
end

app/controllers/users/confirmations_controller.rb
class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/omniauth_callbacks_controller.rb
class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/plataformatec/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/users/passwords_controller.rb
class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
class Users::RegistrationsController < Devise::RegistrationsController
  # before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_up_params
  #   devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute])
  # end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users/sessions_controller.rb
class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cardapio1_helper.rb
module Cardapio1Helper
end

app/helpers/cardapios_helper.rb
module CardapiosHelper
end

app/helpers/entrar_helper.rb
module EntrarHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/index_helper.rb
module IndexHelper
end

app/views/cardapios/_form.html.erb
<%= form_with(model: cardapio, local: true) do |form| %>
  <% if cardapio.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(cardapio.errors.count, "erro") %> ocorreram e portanto,o cardapio não pode ser salvo:</h2>

      <ul>
      <% cardapio.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :nome , class: 'form-control-label' %>
    <%= form.text_field :nome, id: :cardapio_nome , class:'form-control' %>
  </div>

  <div class="field">
    <%= form.label :descricao, class: 'form-control-label' %>
    <%= form.text_area :descricao, id: :cardapio_descricao,class: 'form-control'%>
  </div>

  <div class="field">
    <%= form.label :preco, class: 'form-control-label' %>
    <%= form.text_field :preco, id: :cardapio_preco , class: 'form-control' %>
  </div>

  <div class="field">
    <%= form.label :link_imagem , class: 'form-control-label' %>
    <%= form.text_field :link_imagem, id: :cardapio_link_imagem , class: 'form-control' %>
  </div>

  <br>
  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/cardapios/edit.html.erb
<h1>Edicao de cardapio</h1>

<%= render 'form', cardapio: @cardapio %>

<%= link_to 'Mostrar', @cardapio %> |
<%= link_to 'Voltar', cardapios_path %>

app/views/cardapios/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Cardápio</h1>

<table class = "table table-striped">
  <thead class = "thead thead-default">
  <thead>
    <tr>
      <th>Nome</th>
      <th>Descrição</th>
      <th>Preço</th>
      <th>Link da imagem</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @cardapios.each do |cardapio| %>
      <tr>
        <td><%= cardapio.nome %></td>
        <td><%= cardapio.descricao %></td>
        <td><%= cardapio.preco %></td>
        <td><%= image_tag cardapio.link_imagem %></td>
        <td><%= link_to 'Mostrar', cardapio %></td>
        <td><%= link_to 'Editar', edit_cardapio_path(cardapio) %></td>
        <td><%= link_to 'Destruir', cardapio, method: :delete, data: { confirm: 'Você tem certeza?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'Novo Cardápio', new_cardapio_path %>

app/views/cardapios/new.html.erb
<h1>Novo Cardápio</h1>

<%= render 'form', cardapio: @cardapio %>

<%= link_to 'Voltar', cardapios_path %>

app/views/cardapios/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Nome:</strong>
  <%= @cardapio.nome %>
</p>

<p>
  <strong>Descricao:</strong>
  <%= @cardapio.descricao %>
</p>

<p>
  <strong>Preco:</strong>
  <%= @cardapio.preco %>
</p>

<p>
  <strong>Link imagem:</strong>
  <%= @cardapio.link_imagem %>
</p>

<%= link_to 'Editar', edit_cardapio_path(@cardapio) %> |
<%= link_to 'Voltar', cardapios_path %>

app/views/home/cardapio1.html.erb
<html>

  <head>

  </head>

  <body>
    <div align="center">
    <h3>  Bem vindo(a) ao nosso cardápio !</h3>
    <h3>  Escolha as refeições desejadas e faça o login para fazer sua compra! </h3></div>
    <br>
    <% @cardapio.each do |cardapio| %>

</div>


<div class="shopping-cart">

  <div class="product">
    <div class="product-image">
      <img src=<%=cardapio.link_imagem %> alt="..." class="img-responsive"></div>
    </div>


  <!-- Content here -->

    <div class="product-details">
      <div class="product-title"> <%= cardapio.nome%> </div>
      <p class="product-description"> <%= cardapio.descricao%> </p>
    </div>

    <div class="product-price"> <%=cardapio.preco %> </div>
    <div class="product-quantity">

      <input type="number" value="1" min="0">
    </div>
    <br>

     SubTotal (R$)
    <div class="product-line-price">0.00</div>
  </div>
  <div class="totals">
    <div class="totals-item">


    </div>

  </div>

</div>
<br>
    <form>
      Local de entrega<br>
      <input type = "text" location ="Local de entrega" > <br>
    </form>
    <% @pedido = false %>
      <button onclick="clickAlert()">Comprar</button>
      <% if user_signed_in? %>
          <script>
          function clickAlert(){
          alert("Seu pedido foi processado com sucesso! Aguarde no local de entrega e pague pelo seu pedido");
      }
         </script>
          <% end %>

        <% if !user_signed_in? %>
        <script>
          function clickAlert(){
          alert("Por favor, faça o login para efetivar seu pedido!");
        }
        </script>
          <% end %>
</div>
    <br>
    <br>
      <script>
      /* Set rates + misc */

      /* Set rates + misc */
      var taxRate = 0.05;
      var shippingRate = 15.00;
      var fadeTime = 300;


      /* Assign actions */
      $('.product-quantity input').change( function() {
        updateQuantity(this);
      });

      $('.product-removal button').click( function() {
        removeItem(this);
      });


      /* Recalculate cart */
      function recalculateCart()
      {
        var subtotal = 0;

        /* Sum up row totals */
        $('.product').each(function () {
          subtotal += parseFloat($(this).children('.product-line-price').text());
        });

        /* Calculate totals */

        var total = subtotal;

        /* Update totals display */
        $('.totals-value').fadeOut(fadeTime, function() {
          $('#cart-subtotal').html(subtotal.toFixed(2));
          $('#cart-total').html(total.toFixed(2));
          if(total == 0){
            $('.checkout').fadeOut(fadeTime);
          }else{
            $('.checkout').fadeIn(fadeTime);
          }
          $('.totals-value').fadeIn(fadeTime);
        });
      }


      /* Update quantity */
      function updateQuantity(quantityInput)
      {
        /* Calculate line price */
        var productRow = $(quantityInput).parent().parent();
        var price = parseFloat(productRow.children('.product-price').text());
        var quantity = $(quantityInput).val();
        var linePrice = price * quantity;

        /* Update line price display and recalc cart totals */
        productRow.children('.product-line-price').each(function () {
          $(this).fadeOut(fadeTime, function() {
            $(this).text(linePrice.toFixed(2));
            recalculateCart();
            $(this).fadeIn(fadeTime);
          });
        });
      }


      /* Remove item from cart */
      function removeItem(removeButton)
      {
        /* Remove row from DOM and recalc cart total */
        var productRow = $(removeButton).parent().parent();
        productRow.slideUp(fadeTime, function() {
          productRow.remove();
          recalculateCart();
        });
      }
      </script>

</div>

    <div class="product-removal">
      <button class="remove-product">
        Remover produto da compra
      </button>
    </div>

  <% end %>

    </body>

</html>

app/views/home/fale_conosco.html.erb
 <h2> &nbsp&nbsp Email </h2>
  <h4> &nbsp&nbsp &nbsp&nbsp&nbsp gregoliscotop@gmail.com </h4>

<br>

 <h2>&nbsp&nbsp Telefone </h2>
 <h4> &nbsp&nbsp &nbsp&nbsp&nbsp (61) 3324 5642 </h4>

<br>

 <h2>&nbsp&nbsp Horário de Funcionamento </h2>
 <h4> &nbsp&nbsp &nbsp&nbsp&nbsp Segunda a Sexta:  &nbsp 08h:00 às 18h:00 <br>
	  &nbsp&nbsp &nbsp&nbsp&nbsp Sábado e Domingo:  &nbsp 08h:00 às 12h:00

  </h4>

app/views/home/home.html.erb
<html>

  <head>

    <title>Ep3</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

<h2> &nbsp &nbsp Encontre-nos aqui!</h2> 
<div class="container">

	<div class="row">
		<div class="col-xs-3">
		<address>
		<br><br>
		<h3>Endereço</h3>
		Universidade de Brasília<br>
		Faculdade do Gama (FGA) &nbsp &nbsp <br>
		St. Leste Projeção A <br>
		Gama Leste, Brasília <br>
		DF, 72444-240<br>
		</address>
		</div>
		<div class="col-xs-9">

		<br>

		<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d15341.832794225613!2d-48.04443800000001!3d-15.989645999999999!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x0%3A0x447f05b6f05fa281!2sUniversidade+de+Bras%C3%ADlia+-+Faculdade+do+Gama+%5BFGA%5D!5e0!3m2!1spt-PT!2sbr!4v1512778483176" width="600" height="450" frameborder="0" style="border:0" allowfullscreen></iframe>

</div>
</div>
</div>

  <body>
    <%= yield %>
  </body>

</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <ul>
      <li><a href="home">Home</a></li>
      <li><a href="fale_conosco">Fale conosco</a></li>

      <% if user_signed_in?
      if current_user.email == 'vitor@gmail.com' || current_user.email == 'lclaudio.tl@gmail.com'%>

      <li><a href="cardapios">Cadastrar Produto</a></li>

    <% end %>
    <% end %>
      <br>
    </ul>

    <br>
    <p class="navbar-text pull-right">
        <% if user_signed_in? %>
          Logged in as <strong><%= current_user.email %></strong>.
          <%= link_to 'Editar perfil', edit_user_registration_path, :class => 'navbar-link' %> |
          <%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
        <% end %>
      </p>

    <title>Ep3</title>
      <%= csrf_meta_tags %>
      <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
      <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

        <div class="jumbotron">
      <h1 class="display-3">Gregolisco!</h1>
      <p class="lead">Confira o nosso cardápio e faça seu pedido!</p>

      <p class="lead">
        <%= link_to "Cardápio", cardapio1_path, class: 'btn btn-primary btn-lg' %>
        <%= link_to "Entrar", new_user_session_path, class: 'btn btn-primary btn-lg' %>
        <%= link_to "Cadastrar", new_user_registration_path, class: 'btn btn-primary btn-lg'%>
      </p>
    </div>
  </head>

  <body>
    <p class= " notice"><%=notice %></p>
    <p class = " alert"> <%= alert %> </p>
    <%= yield %>

  </body>
</html>